;Boot Sector for RavenOS 0.1.0    
;Compile with 'nasm -f bin -o <bblock> <bblock.asm>'
;Write to disk with 'debug <bblock>' command 'w 100 0 0 1'

org 0       	         ;We don't want NASM to mess with our addresses
jmp Start                ;Keep the GDT and other data from being executed ;)
nop		         ;Used for anlignment

%include "modules/gdt.inc"       ;Include the GDT (Global Descriptor Table)
%include "modules/video16.inc"   ;We are gonig to need the video functions too

message db 0x41
	db 0x07
	db 0x42
	db 0x07
	dw 0x0

Start:
        ;cli               ;No interupts allowed!

	;xor bx, bx        ;We want the cursor to be at 0,0
	;MoveCursor16

	;mov ax, cs
	;mov es, ax
	;mov si, 0x7cd0
	;PrintString16        
	cli
	lgdt [7c00h+gdt+2]        ;Load the gdt!

;        sti                              ;Interupts on to empty buffer
;        call .WaitEmptyBuffer   ;Wait for empty buffer
;       mov ax, 0xd1                     ;0xd1 is command for write output
;        out 0x64, ax                     ;Send it
;        call .WaitEmptyBuffer   ;Wait for empty buffer
;        mov ax, 0xdf                     ;11011111 is command for keyboard
;        out 0x60, ax                     ;Set the output port
;        call .WaitEmptyBuffer   ;Wait for empty buffer
;        .WaitEmptyBuffer:
;                in ax, 0x64                      ;Read the keyboards Status Resister
;                test ax, 0x2                     ;Is Bit 1 set?
;                loopnz .WaitEmptyBuffer ;Yes?  Loop again...
;        cli

        mov eax, cr0      ;Copy Control Register 0 into EAX
        or al,1            ;Increment EAX
        mov cr0, eax      ;Copy EAX into Control Register 0
	jmp short $+2
	jmp 0x08:pmode+7c00h

[bits 32]
pmode:                       ;If all went well, we are now in protected mode
        mov ax, 0x10
        mov ds, ax        ;Select the data selector
        mov [0xB8000], word 0x4107 ;Put 0x41 'A' at B8000 (text video
buffer)
;        hlt                 ;Nothing more to do... so just halt
	jmp short $

        times 510-($-$$) db 0  ;Move to offset 510 in the BS
        dw 0xAA55              ;Boot Sector identifier
